#include <bits/stdc++.h>
#include <queue>
using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin.exceptions(cin.failbit);

	int T; cin >> T;
	while(T--) {
		int n; cin >> n;
		vector<ll> a(n);
		rep(i, 0, n) cin >> a[i];
		sort(all(a));

		priority_queue<ll> even, odd;
		rep(i, 0, n) {
			if(a[i] % 2 == 0) even.push(a[i]);
			else odd.push(a[i]);
		}

		while(even.size() > 0 && odd.size() > 0) {
			ll big = even.top(), small = odd.top();
			even.pop(); odd.pop();
			if(big < small) swap(big, small);

			if(small == 1) {
				big = big + 1;
				odd.push(big);
			} else {
				big = big + small - 1;
				small = 1;

				even.push(big);
				odd.push(small);
			}
		}

		ll ans = odd.empty() ? even.top() : odd.top();
		cout << ans << '\n';
	}
}

